summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorPaul Eggert <eggert@cs.ucla.edu>2008-03-31 08:37:36 +0200
committerJim Meyering <meyering@redhat.com>2008-03-31 08:37:58 +0200
commite373bb193357481573913ccf28dc14675f172d5a (patch)
tree56d968f7d410e20a1afb4811d71e3bb631fe8f81
parent72e962c97e30fa8a9146d90fa36098137ce0ee0f (diff)
downloadcoreutils-e373bb193357481573913ccf28dc14675f172d5a.tar.xz
dd bug fix: accept e.g., if=/dev/stdin and of=/dev/stdout
* lib/fd-reopen.c: Work even if FILE is "/dev/stdin". Problem reported by Geoffrey Lee in <http://bugs.debian.org/290727>. * tests/dd/misc: Check for this bug.
-rw-r--r--lib/fd-reopen.c8
-rwxr-xr-xtests/dd/misc7
2 files changed, 10 insertions, 5 deletions
diff --git a/lib/fd-reopen.c b/lib/fd-reopen.c
index 2ce467873..c12fef602 100644
--- a/lib/fd-reopen.c
+++ b/lib/fd-reopen.c
@@ -1,6 +1,6 @@
/* Invoke open, but return either a desired file descriptor or -1.
- Copyright (C) 2005, 2006 Free Software Foundation, Inc.
+ Copyright (C) 2005, 2006, 2008 Free Software Foundation, Inc.
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
@@ -31,15 +31,13 @@
int
fd_reopen (int desired_fd, char const *file, int flags, mode_t mode)
{
- int fd;
+ int fd = open (file, flags, mode);
- close (desired_fd);
- fd = open (file, flags, mode);
if (fd == desired_fd || fd < 0)
return fd;
else
{
- int fd2 = fcntl (fd, F_DUPFD, desired_fd);
+ int fd2 = dup2 (fd, desired_fd);
int saved_errno = errno;
close (fd);
errno = saved_errno;
diff --git a/tests/dd/misc b/tests/dd/misc
index 917258236..2b54cfb36 100755
--- a/tests/dd/misc
+++ b/tests/dd/misc
@@ -46,6 +46,13 @@ if dd oflag=append if=$tmp_in of=$tmp_out 2> /dev/null; then
compare $tmp_in $tmp_out || fail=1
fi
+case $(cat /dev/stdin <$tmp_in 2>/dev/null) in
+(data)
+ rm -f $tmp_out
+ dd if=/dev/stdin of=$tmp_out <$tmp_in || fail=1
+ compare $tmp_in $tmp_out || fail=1
+esac
+
if dd iflag=nofollow if=$tmp_in count=0 2> /dev/null; then
dd iflag=nofollow if=$tmp_sym count=0 2> /dev/null && fail=1
fi